/// <reference types="node" />
import * as grpc from 'grpc';
import { EventEmitter } from 'events';
declare type Options = {
    endpoint?: string;
    signature?: string;
    definition?: any;
};
declare class Service {
    private definition;
    private tasks;
    private _client;
    private _token;
    constructor(options?: Options);
    register(signature: string, endpoint: string, serviceHash: string, envHash: string): Promise<grpc.GrpcObject>;
    listenTask({ ...tasks }: Tasks): EventEmitter;
    emitEvent(event: string, data: EventData): Promise<{}>;
    private handleTaskData;
    private validateTaskNames;
    private unaryCall;
}
interface Tasks {
    [task: string]: (inputs: TaskInputs) => TaskOutputs | Promise<TaskOutputs>;
}
interface TaskOutputs {
    [key: string]: any;
}
interface TaskInputs {
    [key: string]: any;
}
interface EventData {
    [key: string]: any;
}
export default Service;
export { Tasks, TaskInputs, };
